"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const getCurrentScriptSource_js_1 = __importDefault(require("./getCurrentScriptSource.js"));
function parseURL(resourceQuery) {
    let options = {};
    if (typeof resourceQuery === "string" && resourceQuery !== "") {
        const searchParams = resourceQuery.slice(1).split("&");
        for (let i = 0; i < searchParams.length; i++) {
            const pair = searchParams[i].split("=");
            options[pair[0]] = decodeURIComponent(pair[1]);
        }
    }
    else {
        // Else, get the url from the <script> this file was called with.
        const scriptSource = (0, getCurrentScriptSource_js_1.default)();
        let scriptSourceURL;
        try {
            // The placeholder `baseURL` with `window.location.href`,
            // is to allow parsing of path-relative or protocol-relative URLs,
            // and will have no effect if `scriptSource` is a fully valid URL.
            scriptSourceURL = new URL(scriptSource, self.location.href);
        }
        catch (error) {
            // URL parsing failed, do nothing.
            // We will still proceed to see if we can recover using `resourceQuery`
        }
        if (scriptSourceURL) {
            // @ts-ignored
            options = scriptSourceURL;
            // @ts-ignored
            options.fromCurrentScript = true;
        }
    }
    return options;
}
exports.default = parseURL;
//# sourceMappingURL=parseURL.js.map